// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package leads

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/crm/crm_models"
)

// NewPostLeadsParams creates a new PostLeadsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostLeadsParams() *PostLeadsParams {
	return &PostLeadsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostLeadsParamsWithTimeout creates a new PostLeadsParams object
// with the ability to set a timeout on a request.
func NewPostLeadsParamsWithTimeout(timeout time.Duration) *PostLeadsParams {
	return &PostLeadsParams{
		timeout: timeout,
	}
}

// NewPostLeadsParamsWithContext creates a new PostLeadsParams object
// with the ability to set a context for a request.
func NewPostLeadsParamsWithContext(ctx context.Context) *PostLeadsParams {
	return &PostLeadsParams{
		Context: ctx,
	}
}

// NewPostLeadsParamsWithHTTPClient creates a new PostLeadsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostLeadsParamsWithHTTPClient(client *http.Client) *PostLeadsParams {
	return &PostLeadsParams{
		HTTPClient: client,
	}
}

/* PostLeadsParams contains all the parameters to send to the API endpoint
   for the post leads operation.

   Typically these are written to a http.Request.
*/
type PostLeadsParams struct {

	/* LeadRequest.

	   An array of new Lead records
	*/
	LeadRequest *crm_models.LeadRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post leads params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostLeadsParams) WithDefaults() *PostLeadsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post leads params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostLeadsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post leads params
func (o *PostLeadsParams) WithTimeout(timeout time.Duration) *PostLeadsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post leads params
func (o *PostLeadsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post leads params
func (o *PostLeadsParams) WithContext(ctx context.Context) *PostLeadsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post leads params
func (o *PostLeadsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post leads params
func (o *PostLeadsParams) WithHTTPClient(client *http.Client) *PostLeadsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post leads params
func (o *PostLeadsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLeadRequest adds the leadRequest to the post leads params
func (o *PostLeadsParams) WithLeadRequest(leadRequest *crm_models.LeadRequest) *PostLeadsParams {
	o.SetLeadRequest(leadRequest)
	return o
}

// SetLeadRequest adds the leadRequest to the post leads params
func (o *PostLeadsParams) SetLeadRequest(leadRequest *crm_models.LeadRequest) {
	o.LeadRequest = leadRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostLeadsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.LeadRequest != nil {
		if err := r.SetBodyParam(o.LeadRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
