// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package database

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetDatabasesParams creates a new GetDatabasesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetDatabasesParams() *GetDatabasesParams {
	return &GetDatabasesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetDatabasesParamsWithTimeout creates a new GetDatabasesParams object
// with the ability to set a timeout on a request.
func NewGetDatabasesParamsWithTimeout(timeout time.Duration) *GetDatabasesParams {
	return &GetDatabasesParams{
		timeout: timeout,
	}
}

// NewGetDatabasesParamsWithContext creates a new GetDatabasesParams object
// with the ability to set a context for a request.
func NewGetDatabasesParamsWithContext(ctx context.Context) *GetDatabasesParams {
	return &GetDatabasesParams{
		Context: ctx,
	}
}

// NewGetDatabasesParamsWithHTTPClient creates a new GetDatabasesParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetDatabasesParamsWithHTTPClient(client *http.Client) *GetDatabasesParams {
	return &GetDatabasesParams{
		HTTPClient: client,
	}
}

/* GetDatabasesParams contains all the parameters to send to the API endpoint
   for the get databases operation.

   Typically these are written to a http.Request.
*/
type GetDatabasesParams struct {

	/* CompanyID.

	   Taxnexus Record Id of a Company
	*/
	CompanyID *string

	/* DatabaseID.

	   Taxnexus Record Id of a Database
	*/
	DatabaseID *string

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip? (default 0)

	   Format: int64
	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get databases params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetDatabasesParams) WithDefaults() *GetDatabasesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get databases params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetDatabasesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get databases params
func (o *GetDatabasesParams) WithTimeout(timeout time.Duration) *GetDatabasesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get databases params
func (o *GetDatabasesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get databases params
func (o *GetDatabasesParams) WithContext(ctx context.Context) *GetDatabasesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get databases params
func (o *GetDatabasesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get databases params
func (o *GetDatabasesParams) WithHTTPClient(client *http.Client) *GetDatabasesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get databases params
func (o *GetDatabasesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCompanyID adds the companyID to the get databases params
func (o *GetDatabasesParams) WithCompanyID(companyID *string) *GetDatabasesParams {
	o.SetCompanyID(companyID)
	return o
}

// SetCompanyID adds the companyId to the get databases params
func (o *GetDatabasesParams) SetCompanyID(companyID *string) {
	o.CompanyID = companyID
}

// WithDatabaseID adds the databaseID to the get databases params
func (o *GetDatabasesParams) WithDatabaseID(databaseID *string) *GetDatabasesParams {
	o.SetDatabaseID(databaseID)
	return o
}

// SetDatabaseID adds the databaseId to the get databases params
func (o *GetDatabasesParams) SetDatabaseID(databaseID *string) {
	o.DatabaseID = databaseID
}

// WithLimit adds the limit to the get databases params
func (o *GetDatabasesParams) WithLimit(limit *int64) *GetDatabasesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get databases params
func (o *GetDatabasesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get databases params
func (o *GetDatabasesParams) WithOffset(offset *int64) *GetDatabasesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get databases params
func (o *GetDatabasesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetDatabasesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.CompanyID != nil {

		// query param companyId
		var qrCompanyID string

		if o.CompanyID != nil {
			qrCompanyID = *o.CompanyID
		}
		qCompanyID := qrCompanyID
		if qCompanyID != "" {

			if err := r.SetQueryParam("companyId", qCompanyID); err != nil {
				return err
			}
		}
	}

	if o.DatabaseID != nil {

		// query param databaseId
		var qrDatabaseID string

		if o.DatabaseID != nil {
			qrDatabaseID = *o.DatabaseID
		}
		qDatabaseID := qrDatabaseID
		if qDatabaseID != "" {

			if err := r.SetQueryParam("databaseId", qDatabaseID); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
