// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tenants

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_models"
)

// PutTenantsReader is a Reader for the PutTenants structure.
type PutTenantsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutTenantsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutTenantsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutTenantsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutTenantsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutTenantsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutTenantsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutTenantsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPutTenantsOK creates a PutTenantsOK with default headers values
func NewPutTenantsOK() *PutTenantsOK {
	return &PutTenantsOK{}
}

/* PutTenantsOK describes a response with status code 200, with default header values.

Taxnexus Response with Tenant objects
*/
type PutTenantsOK struct {
	Payload *sfgate_models.TenantResponse
}

func (o *PutTenantsOK) Error() string {
	return fmt.Sprintf("[PUT /tenants][%d] putTenantsOK  %+v", 200, o.Payload)
}
func (o *PutTenantsOK) GetPayload() *sfgate_models.TenantResponse {
	return o.Payload
}

func (o *PutTenantsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.TenantResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutTenantsUnauthorized creates a PutTenantsUnauthorized with default headers values
func NewPutTenantsUnauthorized() *PutTenantsUnauthorized {
	return &PutTenantsUnauthorized{}
}

/* PutTenantsUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutTenantsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

func (o *PutTenantsUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /tenants][%d] putTenantsUnauthorized  %+v", 401, o.Payload)
}
func (o *PutTenantsUnauthorized) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutTenantsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutTenantsForbidden creates a PutTenantsForbidden with default headers values
func NewPutTenantsForbidden() *PutTenantsForbidden {
	return &PutTenantsForbidden{}
}

/* PutTenantsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PutTenantsForbidden struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

func (o *PutTenantsForbidden) Error() string {
	return fmt.Sprintf("[PUT /tenants][%d] putTenantsForbidden  %+v", 403, o.Payload)
}
func (o *PutTenantsForbidden) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutTenantsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutTenantsNotFound creates a PutTenantsNotFound with default headers values
func NewPutTenantsNotFound() *PutTenantsNotFound {
	return &PutTenantsNotFound{}
}

/* PutTenantsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PutTenantsNotFound struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

func (o *PutTenantsNotFound) Error() string {
	return fmt.Sprintf("[PUT /tenants][%d] putTenantsNotFound  %+v", 404, o.Payload)
}
func (o *PutTenantsNotFound) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutTenantsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutTenantsUnprocessableEntity creates a PutTenantsUnprocessableEntity with default headers values
func NewPutTenantsUnprocessableEntity() *PutTenantsUnprocessableEntity {
	return &PutTenantsUnprocessableEntity{}
}

/* PutTenantsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutTenantsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

func (o *PutTenantsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /tenants][%d] putTenantsUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PutTenantsUnprocessableEntity) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutTenantsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutTenantsInternalServerError creates a PutTenantsInternalServerError with default headers values
func NewPutTenantsInternalServerError() *PutTenantsInternalServerError {
	return &PutTenantsInternalServerError{}
}

/* PutTenantsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PutTenantsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

func (o *PutTenantsInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /tenants][%d] putTenantsInternalServerError  %+v", 500, o.Payload)
}
func (o *PutTenantsInternalServerError) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutTenantsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
